#include	<avr/io.h>
#include	<avr/interrupt.h>

//   ġ
#define	SW_EMERGENCY		PE6
#define	LED_EMERGENCY		PD7
#define	SW_DIR		PE7
#define	DIR_FORWARD	(!(PINE & 1<<SW_DIR))
#define	EMERGENCY	(!(PINE & 1<<SW_EMERGENCY))
#define	EMERGENCY_LED_ON	(PORTD |= 1<<LED_EMERGENCY)
#define	EMERGENCY_LED_OFF	(PORTD &= ~(1<<LED_EMERGENCY))

//  :   ȣ ̺
#define	AC	PB7
#define	BD	PB6
#define	MOTOR_PORT	PORTB
#define	MOTOR_DDR	DDRB

//   ũ 
#define	CLAER	(MOTOR_PORT & 0x3F)
#define	MOTOR_FOREWARD	(MOTOR_PORT = (MOTOR_PORT & CLAER) | 1<<AC)
#define	MOTOR_BACKWARD	(MOTOR_PORT = (MOTOR_PORT & CLAER) | 1<<BD)
#define	MOTOR_STOP		(MOTOR_PORT = (MOTOR_PORT & CLAER) | 1<<AC | 1<<BD)

//  PWM ȣ ̺
#define	OC0	PB4

ISR(ADC_vect)
{	OCR0 = ADC >> 2;	}	// 10Ʈ ADC  8Ʈ 

int	main(void)
{
	MOTOR_DDR |= 1<<AC | 1<<BD;			//   Ʈ AC, BD   
	DDRD |= 1<<LED_EMERGENCY;				// LED_OFF ¹
	PORTE |= 1<<SW_DIR | 1<<SW_EMERGENCY;	// DIR ġ, EMERGENCY ġ Է Ǯ  

	// OC0 PWM 
	DDRB |= 1<<OC0;		           // OC0  
	TCCR0 = 1<<WGM01 | 1<<WGM00;	//  PWM  ߻ 
	TCCR0 |= 1<<COM01 | 1<<COM00;	// TCNT0 0x0 1, ϰ  OCR0 ġϸ 0
	TCCR0 |= 1<<CS02 | 1<<CS00;	// 128  

	// ADC Ȱȭ, ADC ͷƮ Ȱȭ,  , AD , Ϸ CPU ֺ=64
	ADCSRA |= 1<<ADEN | 1<<ADIE | 1<<ADFR | 1<<ADSC | 6;
	sei();

	while(1){
		if( EMERGENCY ){
			MOTOR_STOP;
			EMERGENCY_LED_ON;
		}else{
			EMERGENCY_LED_OFF;
			if( DIR_FORWARD)
				MOTOR_FOREWARD;
			else
				MOTOR_BACKWARD;
		}
	}
	
	return 0;
}
